<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
    />
    <!-- Popper Development version -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import them style bootstrap cho datatable -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />

    <!-- Import DataTable Library -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/jquery.dataTables.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <title>Task 38.30</title>
  </head>

  <body>
    <div class="container mt-4">
      <div class="text-center mt-2 mb-2">
        <h2>Lucky Dice History</h2>
      </div>
      <div class="row jumbotron p-3 m-0">
        <div class="col-md-12">
          <form>
            <div class="form-row">
              <h5>Thông tin người chơi</h5>
            </div>
            <div class="form-row">
              <div class="form-group col-md-4">
                <label>Username</label>
                <input
                  type="text"
                  id="user-name"
                  class="form-control bg-secondary text-white"
                  disabled
                />
              </div>
              <div class="form-group col-md-4">
                <label>First Name</label>
                <input
                  type="text"
                  id="first-name"
                  class="form-control bg-secondary text-white"
                  disabled
                />
              </div>
              <div class="form-group col-md-4">
                <label>Last Name</label>
                <input
                  type="text"
                  id="last-name"
                  class="form-control bg-secondary text-white"
                  disabled
                />
              </div>
            </div>
          </form>
        </div>
        <div id="log-result" class="mt-5"></div>
        <div class="mt-5">
          <table
            id="table-dice-history"
            class="table table-bordered table-striped table-hover"
          >
            <thead class="thead-dark">
              <tr>
                <th scope="col">Game</th>
                <th scope="col">Dice</th>
              </tr>
            </thead>
            <tbody></tbody>
          </table>
        </div>
      </div>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
      var gPlayerInfoObj = {};
      var gDiceHistoryData = [];

      var gNameCol = ["stt", "dice"];
      const gSTT_COL = 0;
      const gDICE_POINT_COL = 1;

      var gPlayerDataTable = $("#table-dice-history").DataTable({
        columns: [
          { data: gNameCol[gSTT_COL] },
          { data: gNameCol[gDICE_POINT_COL] },
        ],
        columnDefs: [
          {
            targets: gSTT_COL,
            className: "text-center text-primary",
            render: function (data, type, row, meta) {
              return meta.row + meta.settings._iDisplayStart + 1;
            },
          },
          {
            targets: gDICE_POINT_COL,
            className: "text-center text-success",
          },
        ],
      });

      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        var vCurrentURL = window.location.href;
        catchDataFromURL(vCurrentURL);
        loadPlayerInfoToForm(gPlayerInfoObj);
        getPlayerDiceHistory(gPlayerInfoObj.userName);
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm xử lý thực hiện lấy queryString từ url trang web
      function catchDataFromURL(paramCurrentURL) {
        "use strict";
        var vNewUrl = new URL(paramCurrentURL);
        //get parameters
        var vUname = vNewUrl.searchParams.get("user_name");
        var vFname = vNewUrl.searchParams.get("first_name");
        var vLname = vNewUrl.searchParams.get("last_name");
        //save to var global
        gPlayerInfoObj.userName = vUname;
        gPlayerInfoObj.firstName = vFname;
        gPlayerInfoObj.lastName = vLname;
        //show result in console.log
        console.log(
          "gOrderParamsObj = " + JSON.stringify(gPlayerInfoObj, true, 2)
        );
      }

      function loadPlayerInfoToForm(paramDataObj) {
        $("#user-name").val(paramDataObj.userName);
        $("#first-name").val(paramDataObj.firstName);
        $("#last-name").val(paramDataObj.lastName);
      }

      function getPlayerDiceHistory(paramUserName) {
        console.log(paramUserName);
        $.ajax({
          url: gBASE_URL + "/dice-history?username=" + paramUserName,
          async: false,
          type: "GET",
          dataType: "json",
          success: function (responseObj) {
            console.log("responseText " + JSON.stringify(responseObj));
            if (responseObj.dices.length > 0) {
              var vCount = 0;
              while (vCount < responseObj.dices.length) {
                var bDice = { game: vCount, dice: responseObj.dices[vCount] };
                gDiceHistoryData.push(bDice);
                vCount++;
              }
              loadDataToDiceTable(gDiceHistoryData);
            }
          },
          error: function (xhr, status, error) {
            console.log(error);
          },
        });
      }

      function loadDataToDiceTable(paramVoucherArr) {
        console.log(paramVoucherArr);
        gPlayerDataTable.clear();
        gPlayerDataTable.rows.add(paramVoucherArr);
        gPlayerDataTable.draw();
      }
    </script>
  </body>
</html>
